# -*- coding: utf-8 -*-
"""
Created on Thu Sep  9 11:56:41 2021

@author: hugo
"""
import csv
import numpy as np 
import matplotlib.pyplot as plt

def charge_fichier_csv(fichier, delimiter=";",N=0):
    """
    Charge un fichier csv et le renvoie sous forme de tableau

    :param: nom de fichier, délimiteur de cellules (par défaut ";"),
    nombre de lignes d'en-tête (en comptant les lignes vides)
    :returns: tableau des données
    """

    with open(fichier, 'r') as f :
        rfichier = csv.reader(f, delimiter=delimiter)
        tableau=[]
        index_row=0
        for row in rfichier:
            if index_row < N:
                index_row = index_row+1
            else :
                for i in range (len(row)):
                    if len(tableau) <= i:
                        X = []
                        tableau.append(X)
                    try:
                        tableau[i].append(float(row[i].replace(",",'.')))
                    except ValueError:
                        print('erreur:contenu de cellule non numerique')
                        continue

        return (tableau)
tableau=charge_fichier_csv('meteo_moy.csv',delimiter=";",N=1)
H1a=tableau[4]
H1b=tableau[5]
H1c=tableau[6]
H2a=tableau[7]
H2b=tableau[8]
H2c=tableau[9]
H2d=tableau[10]
H3=tableau[11]
# print(H1a)
h1a=[40.5, 60.6, 98.5, 139.5, 159.9, 180.2, 130.1, 163.0, 131.9, 89.9, 32.6, 37.2]
h1b=[45.7, 62.3, 110.2, 147.4, 173.0, 157.2, 127.0, 150.7, 154.1, 57.5, 33.3, 23.0]
h1c=[33.0, 79.0, 127.5, 146.1, 146.9, 190.4, 140.5, 169.0, 98.7, 75.7, 44.0, 42.8]
h2a=[43.2, 68.6, 120.5, 146.5, 185.8, 184.6, 135.5, 163.0, 158.8, 86.2, 48.7, 46.3]
h2b=[56.6, 77.8, 126.2, 174.2, 205.9, 236.2, 167.7, 196.2, 204.3, 78.9, 58.7, 32.6]
h2c=[62.6, 86.5, 140.7, 153.0, 180.4, 196.9, 152.0, 174.3, 178.0, 101.9, 50.8, 41.3]
h2d=[97.9, 135.3, 185.5, 212.4, 214.4, 293.7, 217.5, 256.1, 196.4, 128.9, 105.5, 93.7]
h3=[120.2, 153.9, 179.4, 209.0, 247.8, 273.8, 219.9, 241.4, 173.6, 144.3, 92.0, 98.3]

liste_mois=[[31,14,10],[28,13,11],[31,12,12],[30,10,14],[31,8,16],[30,8,16],[31,8,16],[31,9,15],[30,11,13],[31,13,11],[30,15,9],[31,15,9]]
#liste mois est une liste contenant 3 infos pour chaque moi (mois  janvier etc ) le nb de jours du mois
#le nombre d''heure de nuit par jour , et le nombre de jours par jours 
#mois=[janvier,fevrier,mars,avril,mai,juin,juillet,août,septembre,octobre,novembre,décembre]
   
def creation_liste_annee (zone_geo,liste_mois):
    liste_annee=[]
   #objectif créer la liste année  soit 365 element(jours) contenant 24 (heurs et ensolleillement)element avec les heure de nuit ou y'a 0 soleil et les heure de jours qui sont la moyenne solaire du mois divisee par le nombre d'heure ensolleiller 
   #ci-dessous heure du matin 
    for mois in range (len(liste_mois )): 
           for jour_par_moi in range (liste_mois[mois][0]):
               liste_jour=[]
               if liste_mois[mois][2]%2==0:
                   for w in range (int(liste_mois[mois][1]//2)):
                       liste_jour.append(0)
                       
               else:
                  for w in range (int(liste_mois[mois][1]//2)+1):
                      liste_jour.append(0)
                      
              #ci dessus on ajoute les heure de soleil 
               for heure_soleil in range(liste_mois[mois][2]):
                    ratio_moy_heure_soleil=liste_mois[mois][0]/liste_mois[mois][2]
                    liste_jour.append(zone_geo[mois]*ratio_moy_heure_soleil)
              # ci-dessous heure de la après midi nuit 
               for i in range (int(liste_mois[mois][1]//2)):
                   liste_jour.append(0)
               liste_annee.append(liste_jour)
    return liste_annee

def Specification_jour_semaine(liste_annee,heure_aller,heure_retour): 
    annee=[]
    jour=[]
    l=0
    
   
    semaine=['lundi','mardi','mercredi','jeudi','vendredi','samedi','dimanche']
    for i in range ((len(liste_annee))):
        
        jour.append(liste_annee[i]) 
        #le 0 c'est l'indicateur d'activité pourune heure donné 
                               
        jour.append(semaine[l])
        #if jour[-1]=='dimanche':
         #   jour[0][heure_promenade_dimanche]=2
      #  else:    
                        
           # jour[0][heure_aller-1]=1
         #  " jour[0][heure_retour-1]=1
        annee.append(jour)
        jour=[]
        
        if l==6:
            l=0
        else:
            l=l+1
        continue
            
            
        annee.append(jour)
    return annee



def Capacite_batt_dans_le_temps(liste_annee,conso_WH_par_km, capacite_batt,distance_moyenne,heure_de_rentre,heure_de_sortie):
    rendement_panneau=0.15
    surface_panneau=1
    capacite_batt_reel=capacite_batt
   
    compteur_de_charges=0
    liste_finale=[]
    prix_moyen_kwh=0.146
    activite=0
    
    
    for jours in range(len( liste_annee)):
       
       
       
        for heures in range(len(liste_annee[jours][0])):#ya le jour dans la semaine en 25 position
            
            infos=liste_annee[jours][0]#selection de la liste avec l'ensolleillement sur une journée
           
            
            if liste_annee[jours][1]!='dimanche':
               
                if heures==heure_de_rentre or heures==heure_de_sortie:
                    activite=1
                    
                else:
                        activite=0
            else:
                activite=0
                
           
            capacite_batt_reel=capacite_batt_reel+ infos[heures]*rendement_panneau*surface_panneau*1-activite*conso_WH_par_km*distance_moyenne/2
            if capacite_batt_reel>capacite_batt:
                capacite_batt_reel=capacite_batt
            if capacite_batt_reel<=0:
                capacite_batt_reel=capacite_batt
                
                compteur_de_charges=compteur_de_charges+1
            infos.append(capacite_batt_reel)
            liste_finale.append(capacite_batt_reel)
   
    return liste_finale,liste_annee,compteur_de_charges,compteur_de_charges*(capacite_batt/1000)*prix_moyen_kwh

def consommation_wh_par_km_estimation (denivele):
    if denivele==0:
        return 16
    if denivele>500:
        return 25
    return 16+(9/500)*denivele# approximation inéaire de la consommation éléctrique 

#%%
meteo=h1a
capacite_battrie_desiree=700
distance_moyenne_jour=10
denivele=100
heure_aller=8
heure_retour=16

annee=creation_liste_annee(meteo,liste_mois)    
annee2=Specification_jour_semaine(annee,heure_aller,heure_retour)    
liste_finale,liste_annee,compteur_de_charges,prix_annee=Capacite_batt_dans_le_temps(annee2,consommation_wh_par_km_estimation(denivele),capacite_battrie_desiree,distance_moyenne_jour,heure_aller,heure_retour)

plt.figure(1)


abs=np.linspace(0,8759,8760)

ord=liste_finale
plt.plot(abs,ord)
plt.xlabel('heures')
#plt.grid(True)
plt.ylabel('Wh dans la batterie ')
plt.title(" Wh dans la batterie e fonction de l'annee " )
plt.legend()

plt.show()
print(compteur_de_charges)
print(prix_annee)                
                   
   
# def import_data(lien_zone_climatique):#fonction permettant de récupèrer es données d'ensolleillement
#     #par heures sur la zone géographique concerné
#     lines = urllib.request.urlopen(lien_zone_climatique).readlines()
    
    
#     liste_data=[]
#     del lines[0]
#     for line in lines:
#            line=line.decode("utf-8") 
#            line = line.split(';')
#            data=line[0]
          
#            data_float=float(data)
           
#            liste_data.append(data_float)
#     return liste_data


